## DONE

  * 配置支持css modules

  * 配置支持sass、less预编译

  * 配置支持postcss插件pxtorem

  * 配置支持flow type检查

  * 配置更为严格的Eslint规则

  * 配置stylelint检查

  * 直接引入babel-polyfill

  * 配置支持react hot loader

  * babel-polyfill\react\react-dom\react-router-dom这几个资源配置为CDN访问

  * 配置支持Webpack Bundle Analyzer

## TODO

  * ESDoc

  * PM2

## 环境变量配置

  配置名=(default value)

  * 构建开发Node server时配置端口号
    PORT=3000

  * 构建开发Node server时配置的域名
    HOST=localhost

  * 开发时配置opn库options参数app属性值，none不主动打开浏览器，不配置默认打开
    BROWSER

  * 打包生产文件夹项目路径
    APP_BUILD=build

  * 配置页面html文件路径
    APP_HTML=public/index.html

  * 项目public文件夹
    APP_PUBLIC=public

  * 入口JavaScript文件
    APP_INDEXJS=src/index.js

  * 项目源码目录
    APP_SRC=src

  * CDN的url设置
    PUBLIC_URL=/

  * 生产打包JavaScript文件以及CSS文件是否生成source map文件，判定是否不等于字符串"false"
    GENERATE_SOURCEMAP=true

  * 是否采用HTTPS, 判定是否等于字符串"true"
    HTTPS=

  * 样式文件是否采用css-modules, 判定是否等于字符串"true", 采用css-modules也留了一个缺口文件夹。源目录下的APP_SRC/assets文件夹不进行css modules处理
    CSS_MODULES=

  * 采用预编译器, 判定是否等于less或者sass
    PREPROCESSOR=

  * POSTCSS中是否进行px单位到rem单位到转换，判定是否是数字, 请配置`${(document.documentElement.clientWidth / 设计图宽度) * REACT_APP_PXTOREM}px`的fontSize属性, 确保别小于12px
    REACT_APP_PXTOREM=

  * Webpack Bundle Analyzer端口
    ANALYZER_PORT=3003

## 开发环境下代理

  *  package.json文件中的proxy属性

## React hot loader

root上挂载的组件需要使用react-hot-loader库中的AppContainer包裹起来，并且Webpack Hot Module Replacement API需要调用

```js
import React from 'react'
import ReactDOM from 'react-dom'
import { AppContainer } from 'react-hot-loader'
import App from './containers/App'

const render = Component => {
  ReactDOM.render(
    <AppContainer>
      <Component />
    </AppContainer>,
    document.getElementById('root'),
  )
}

render(App)

if (module.hot) {
  module.hot.accept('./containers/App', () => { render(App) })
}
```
## template中插入script标签，引入babel-polyfill\react\react-dom\react-router-dom几个包
